 /*******************************************************************************

    VOLTIMETRO DIGITAL 0 A +50 VOLTS  (DELTA-SIGMA)

    (VERSO 7 SEGUIMENTOS NODO COMUM)

    AUTOR: CLAUDIO LRIOS

    DATA: 09/11/2022

    COM  AT89C2051

    OBS. MONTAGEM  DE NATUREZA DIDTICA
    USE COMPILADOR MIKROC FOR 8051 V.3.6.0

    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG PICSOURCE
*******************************************************************************/
//BIT

sbit   a2    at  P1.B3; //nodo do display das dezenas
sbit   a1    at  P1.B4; //nodo do display das unidades
sbit   a0    at  P1.B5; //nodo do display dos dcimos de volts
sbit   bt    at  P1.B2; //boto de jogada     pino 14
sbit   buzzer    at  P1.B1; // sada para buzzer
sbit   btx    at  P1.B7; //boto de teste     pino 19
sbit   jmp    at  P1.B6; //jumper som tec-tec ou no  pino 18
//sbit   cout  at  P3.B6; //sada do comparador interno

char un,dez,cent,vez,c,d,una,tap,cnt1,vez2,vez3,vez1;
unsigned int res,aa,tt;
unsigned long v1;
bit frodar;


 #define  FATOR_GIRO  255  //fator usado na operao de giro final
 #define DELAY_PRE_MENSAGEM 7500  //tempo apos jogada para mostrar PLAY rodando

const char num[]= {
       0b11000000, //0  0xc0
       0b11111001, //1  0xf9
       0b01100100, //2  0x64
       0b01110000, //3  0x70
       0b01011001, //4  0x59
       0b01010010, //5  0x52
       0b01000010, //6  0x42
       0b11111000, //7  0xf8
       0b01000000, //8  0x40
       0b01010000, //9  0x50
};

void multiplexa(){
    a2=1;
    a1=1;
    a0=1;
    if(++vez>2)vez=0;
    if(vez==0){P3=un; a0=0;}    //mostra unidades
    if(vez==1){P3=dez; a1=0;}   //mostra dezenas
    if(vez==2){P3=cent; a2=0;}  //mostra centenas
}


void delay_mpx( char valor){
  char d;
  for(d=0;d<valor;d++){
      multiplexa();
      delay_ms(1);
  }
}

 void delay_giro(char g){//simula velocidade decrescente no giro dos 7 seg
     if(jmp)buzzer=1;//sem jumper liga buzzer
     g=~g;
     if(g>FATOR_GIRO-77) {delay_mpx(10);}//
     if(g>FATOR_GIRO-60) {delay_mpx(11);}//
     if(g>FATOR_GIRO-48) {delay_mpx(13);}//
     if(g>FATOR_GIRO-37) {delay_mpx(17);}//
     if(g>FATOR_GIRO-29) {delay_mpx(20);}//
     if(g>FATOR_GIRO-23) {delay_mpx(23);}//
     if(g>FATOR_GIRO-18) {delay_mpx(28);}//
     if(g>FATOR_GIRO-14) {delay_mpx(33);}//
     if(g>FATOR_GIRO-9) {delay_mpx(40);}//
     if(g>FATOR_GIRO-5) {delay_mpx(55);}//
     if(g>FATOR_GIRO-3) {delay_mpx(70);}//
     if(g>FATOR_GIRO-2) {delay_mpx(200);}//
     if(g>FATOR_GIRO-1) {delay_mpx(500);}//
     delay_mpx(8);
     buzzer=0;//desliga buzzer
}


void pega_digito(){
 while(v1>=10000){v1=v1-10000; } //elimina casa das dezenas de milhares
 while(v1>=1000){v1=v1-1000; } //elimina casa dos milhares
 cent=0;
 while(v1>=100){v1=v1-100; cent++;} //separa as centenas
 dez=0;
 while(v1>=10){v1=v1-10; dez++;} //separa as dezenas
 un=v1; //separa a unidade

 cent=num[cent];  //converte para 7 seguimentos
 dez=num[dez];
 un=num[un];
}
 void play_win(){
    char w,f,h,j,k;
    for(w=0;w<3;w++){
      for(f=0;f<250;f++){
         buzzer=1;
         delay_mpx(1);
         buzzer=0;
      }

      for(h=0;h<20;h++){
        for(f=16;f<120;f++){
         buzzer=1;
          for(j=0;j<f;j++){
           delay_us(1);
          }
         buzzer=0;
        }
        multiplexa();
      }


       for(h=0;h<30;h++){
        for(f=80;f>12;f--){
         buzzer=1;
          for(j=0;j<f;j++){
           delay_us(1);
          }
         buzzer=0;
        }
        multiplexa();
      }
    }
}
 void efeito(){
 char a;
     while(frodar){
       vez3++;
       if(vez3>=5){res=res-100; vez3=0;}
       if(vez3==3)res=res-10;
       v1= res--;
       v1= v1 + 67232;  //soma o complemento para nmero mximo 99999

       delay_giro(cnt1);
       pega_digito();
       if(cnt1)cnt1--;
       if(cnt1==0){
         frodar=0;
         if((cent == dez)&& (dez==un)) {
          play_win(); //toca notas
         }
       }
     }
 
 
 }
 void jogar(){
  cnt1=0;
   while(bt==0){
    vez1++;
    if(vez1>=10){ 
      if(jmp)buzzer=1; //testa jumper -> sem jmp= som / com jmp= sem som
      vez1=0;
    }
     frodar=1;
     res=rand();

     v1= res;
     v1= v1 + 67232;  //soma o complemento para nmero mximo 99999
     pega_digito();
     multiplexa();
     delay_ms(2);
     buzzer=0;
     if(cnt1<155)cnt1++;
     tt=DELAY_PRE_MENSAGEM;
   }

 }

/*************************************************************************
       Rotina Main
*************************************************************************/
void main() {
     P1=0b11111111;  //desliga anodos /p1.0 e p1.1 em '1' para funcionar comparador
     P3=0x00;  //desliga
     vez1=0;
     vez=0; 
     vez3=0;
     una=0;
     d=0;
     frodar=0;
     un=0x08;  //A
     dez=0xC7; //L
     cent=0x0C; //P
     tt=0;

 /*************************************************************************
       Lao Infinito
*************************************************************************/

  for(;;){

     jogar();
     efeito();
     multiplexa();
     delay_ms(2);
     if(tt>0){   //mostra PLAy (jogar)
       tt--; 
     }
     else{
     if(++vez2>7)vez2=0;
       switch (vez2){
        case 0:
         un=0xff;  //apagar todos seguimentos
         dez=0xff; //
         cent=0xff; //
         break;
        case 1:
         un=0x0c;  //letra P   nas unidades
         dez=0xff; //apagado
         cent=0xff; //apagado
         break;
        case 2:
         un=0xc7;  //letra L   nas unidades
         dez=0x0c; //letra P   nas dezenas
         cent=0xff; //apagado
         break;
       case 3:
         un=0x08;  //A  (no usa bit 6 = saida do comparador)
         dez=0xC7; //L
         cent=0x0C; //P
         break;
        case 4:
         un=0x11;  //Y  (no usa bit 6 = saida do comparador)
         dez=0x08; //A
         cent=0xc7; //L
         break;
        case 5:
         un=0xff;  //apagado
         dez=0x11; //Y
         cent=0x08; //A
         break;
        case 6:
         un=0xff;  //apagado
         dez=0xff; //apagado
         cent=0x11; //Y
         break;
        case 7:
         un=0xff;  //apagado
         dez=0xff; //apagado
         cent=0xff; //apagado
         break;
       }//switch vez
     delay_mpx(250);
     delay_mpx(50);
     }//else
     
     
     //teste apenas
     if(btx==0){
       play_win();
       while(btx==0)delay_mpx(1);
     }
     //teste apenas
 }//for(;;)
}  //main()